<?php

namespace OrganizationsManagement\Factory;

use OrganizationsManagement\Util\InstanceProvider;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;
use Teknisa\Model\Teknisa\Entities\OmComandoEstrutura as OmComandoEstruturaEntity;
use Teknisa\Model\Teknisa\Entities\OmComandoEstruturaUrl as OmComandoEstruturaUrlEntity;

class ComandoEstrutura
{
    public function save(OmComandoEstruturaEntity $entity = null, $dscomandoest, $nrordem,
                         $comando, $idtpcomando, $idambcomando, $idacaoexecom, $idativo = 'S')
    {
        $dateNow     = new \DateTime();
        $nrorg       = InstanceProvider::getEnvironment()->getCurrentOrganizationId();
        $codOperador = InstanceProvider::getEnvironment()->getCurrentUserId();

        if ($entity === null) {
            $entity = new OmComandoEstruturaEntity();
            $novoCodigo = NovoCodigo::geraCodigo($nrorg, "OM_COMANDO_ESTRUTURA", 1, 10, false, false);
            $entity->setId($novoCodigo);
            $entity->setCdoperinclusao($codOperador);
            $entity->setDtinclusao($dateNow);
            $entity->setNrorg($nrorg);
            $entity->setNrorginclusao($nrorg);
        }

        $entity->setCdoperultatu($codOperador);
        $entity->setDtultatu($dateNow);
        $entity->setNrorgultatu($nrorg);

        $entity->setDscomandoest($dscomandoest);
        $entity->setNrordem($nrordem);
        $entity->setComando($comando);
        $entity->setIdtpcomando($idtpcomando);
        $entity->setIdambcomando($idambcomando);
        $entity->setIdacaoexecom($idacaoexecom);
        $entity->setIdativo($idativo);

        return $entity;
    }

    public function saveUrl(OmComandoEstruturaUrlEntity $entity = null, $commandId, $url, $idativo = 'S')
    {
        $dateNow     = new \DateTime();
        $nrorg       = InstanceProvider::getEnvironment()->getCurrentOrganizationId();
        $codOperador = InstanceProvider::getEnvironment()->getCurrentUserId();

        if ($entity === null) {
            $entity = new OmComandoEstruturaUrlEntity();
            $novoCodigo = NovoCodigo::geraCodigo($nrorg, "OM_COMANDO_ESTRUTURA_URL", 1, 10, false, false);
            $entity->setId($novoCodigo);
            $entity->setCdoperinclusao($codOperador);
            $entity->setDtinclusao($dateNow);
            $entity->setNrorg($nrorg);
            $entity->setNrorginclusao($nrorg);
        }

        $entity->setCdoperultatu($codOperador);
        $entity->setDtultatu($dateNow);
        $entity->setNrorgultatu($nrorg);

        $entity->setComandoEstruturaId($commandId);
        $entity->setDswebserviceurl($url);
        $entity->setIdativo($idativo);

        return $entity;
    }
}
