<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeEscalatrabm extends \Doctrine\ORM\EntityRepository {
       
    
    public function getEscalatrabm($nrOrg){
    	$params = array('nrorg'=>$nrOrg);
        $gpe_Escalatrabm =  '\Teknisa\Model\Gestaopessoas\Entities\GpeEscalatrabm';

$sql = <<<SQL
SELECT s FROM $gpe_Escalatrabm s
WHERE s.nrorg = :nrorg
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaEscalaTrab($nrescalatrabm, $nrorg){
    	$params = array('nrescalatrabm' => $nrescalatrabm, 'nrorg'=>$nrorg);
        $gpe_Escalatrabm =  '\Teknisa\Model\Gestaopessoas\Entities\GpeEscalatrabm';
    
$sql = <<<SQL
SELECT s FROM $gpe_Escalatrabm s
WHERE s.nrorg = :nrorg
    and s.nrescalatrabm = :nrescalatrabm    
SQL;
            $result = $this->getEntityManager()->createQuery($sql)->execute($params);
            return $result[0];
        }
        
    public function retornaEscalaTrabalhoPorHorario($dia, $codhorcontrat, $qtdhrssem, $tpjornada, $nrorg, $dtmescompetenc){
        
        $params = array('p_dia' => $dia, 'p_codhorcontrat' => $codhorcontrat, 'p_qtdhrssem' => $qtdhrssem, 'p_tpjornada' => $tpjornada, 'p_nrorg' => $nrorg, 'p_dtmescompetenc' => $dtmescompetenc);
        
        $gpe_hordiam =  '\Teknisa\Model\Gestaopessoas\Entities\GpeHordiam';
        $gpe_horarioturno =  '\Teknisa\Model\Gestaopessoas\Entities\GpeHorarioturno';
        $gpe_turno =  '\Teknisa\Model\Gestaopessoas\Entities\GpeTurno';
        $gpe_Escalatrabh =  '\Teknisa\Model\Gestaopessoas\Entities\GpeEscalatrabh';
        $pto_tipojornada =  '\Teknisa\Model\Gestaopessoas\Entities\PtoTipojornada';
        
$sql = <<<SQL
   SELECT gpe_hordiam.nrhordiam,
          gpe_horarioturno.nrhorarioturno,
          gpe_turno.nrturno,
          gpe_escalatrabh.nrescalatrabm
     FROM $gpe_hordiam gpe_hordiam
LEFT JOIN $gpe_horarioturno gpe_horarioturno WITH gpe_horarioturno.nrhordiam = gpe_hordiam.nrhordiam
                                            AND gpe_horarioturno.nrorg = gpe_hordiam.nrorg
LEFT JOIN $gpe_turno gpe_turno WITH gpe_turno.nrturno = gpe_horarioturno.nrturno
                              AND gpe_turno.nrorg = gpe_horarioturno.nrorg
LEFT JOIN $gpe_Escalatrabh gpe_escalatrabh WITH gpe_escalatrabh.nrescalatrabm = gpe_turno.nrescalatrabm
                                          AND gpe_escalatrabh.nrorg = gpe_turno.nrorg
                                          AND gpe_escalatrabh.dtmescompetenc = (SELECT MAX(eh.dtmescompetenc)
                                                                                  FROM $gpe_Escalatrabh eh
                                                                                 WHERE eh.nrescalatrabm = gpe_escalatrabh.nrescalatrabm
                                                                                   AND eh.nrorg = gpe_escalatrabh.nrorg
                                                                                   AND eh.dtmescompetenc <= :p_dtmescompetenc)
LEFT JOIN $pto_tipojornada pto_tipojornada WITH pto_tipojornada.nrtpjornada = gpe_escalatrabh.nrtpjornada                                                                  
    WHERE ((gpe_horarioturno.nrseqhorario = (:p_dia + 2) and :p_dia <> 8) or (:p_dia = 8 and gpe_horarioturno.iddiavariavel = 's'))
      AND gpe_hordiam.nrhordiam = :p_codhorcontrat
      AND gpe_escalatrabh.qthrsemesctrabh = :p_qtdhrssem
      AND pto_tipojornada.cdesocial = :p_tpjornada
      AND gpe_hordiam.nrorg = :p_nrorg

SQL;
    
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result[0];
        
    }
}